% Dati
global m J Fx1 Fx2 Fy1 Fy2 S Cx rho a b Raggio del_eq u_eq v_eq r_eq C K A B Af
m=(540*sqrt(2)+225);
J=300;
Fx1=800;
Fx2=500;
Fy1=400;
Fy2=250;
S=2;
Cx=0.8;
rho=1.5;
a=1;
b=12*sqrt(2)/5;
Raggio=90;
del_eq=pi/4;
u_eq=10
r_eq=u_eq/Raggio
% Soluzione
v_eq=-Raggio/(m*u_eq)*(Fx1*cos(del_eq)+Fx2-Fy1*sin(del_eq)-0.5*rho*S*Cx*u_eq^2)
% Verifica equilibrio
u_punto_eq=v_eq*r_eq+1/m*(Fx1*cos(del_eq)+Fx2-Fy1*sin(del_eq)-0.5*rho*S*Cx*(u_eq)^2)
v_punto_eq=-u_eq*r_eq+1/m*(Fy1*cos(del_eq)+Fy2+Fx1*sin(del_eq))
r_punto_eq=1/J*(Fy1*a*cos(del_eq)-Fy2*b+Fx1*a*sin(del_eq))
pause
% Sistema linearizzato
A=[-rho*S*Cx*u_eq/m r_eq v_eq;-r_eq 0 -u_eq;0 0 0]
autov=eig(A)
B=[-1/m*(Fx1*sin(del_eq)+Fy1*cos(del_eq));1/m*(Fx1*cos(del_eq)-Fy1*sin(del_eq));1/J*(Fx1*a*cos(del_eq)-Fy1*a*sin(del_eq))]
C=[1/r_eq 0 -u_eq/r_eq^2]
D=0
sys=SS(A,B,C,D);
sistema=zpk(sys)
pause
% Raggiungibilit ed osservabilit
Rg=ctrb(A,B)
rank(Rg)
Ob=obsv(A,C)
rank(Ob)
pause
% Calcolo coeff smorzamento
Sovr_percent=0.2;
smorz=sqrt((log(Sovr_percent))^2/(pi^2+(log(Sovr_percent))^2))
fi_max=acos(smorz)
pause
% Progetto del regolatore
prdom=-0.035;
p=[prdom-i*(tan(fi_max)*prdom) prdom+i*(tan(fi_max)*prdom) -7]
q=2*p
K=acker(A,B,p)
L=transpose(acker(A',C',q))
rsys=reg(sys,K,L);
regolatore=zpk(rsys)
[Ar,Br,Cr,Dr]=SSdata(rsys);
pause
fsys=feedback(series(rsys,sys),1,1);
finale=zpk(fsys)
[Af,Bf,Cf,Df]=ssdata(fsys);
figure(1)
clf
step(-finale)
pause
% Stima R.A.S. con Lyapunov
Stima_RAS_Lyapunov